using System.Web.Mvc;
using GridDataBinding.Models;

namespace Infragistics.IgniteUi.Samples 
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            GridModel gridModel = GetGridModel();
            return View(gridModel);
        }

        private GridModel GetGridModel()
        {
            GridModel gridModel = new GridModel();
            gridModel.DataSourceUrl = Url.Action("GetData");
            gridModel.AutoGenerateColumns = false;

            gridModel.Columns.Add(new GridColumn()
            {
                Key = "ProductID",
                HeaderText = "ProductID"
            });
            gridModel.Columns.Add(new GridColumn()
            {
                Key = "Name",
                HeaderText = "Name"
            });
            gridModel.Columns.Add(new GridColumn()
            {
                Key = "ProductNumber",
                HeaderText = "ProductNumber"
            });
            return gridModel;
        }

        public JsonResult GetData()
        {
            GridModel gridModel = GetGridModel();
            gridModel.DataSource = this.GetProducts().AsQueryable();
            return gridModel.GetData();
        }

        private List<Product> GetProducts()
        {
            List<Product> products = new List<Product>()
        {
            new Product() { ProductID = 1, Name = "Adjustable Race", ProductNumber = "AR-5381" },
            new Product() { ProductID = 2, Name = "Bearing Ball", ProductNumber = "BA-8327" }
        };

            return products;
        }
    }
}